from typing import Any, Dict

from app.storage.persistent_event import PersistentEvent


class BaseEvent:
    def __init__(self, *, uuid: str, **kwargs) -> None:
        self.uuid = uuid
        self.kwargs = kwargs
        self.timestamp = None

    def to_dict(self) -> Dict[str, Any]:
        return self.kwargs

    @classmethod
    def from_persistent_event(cls, event: PersistentEvent) -> "BaseEvent":
        props = event.props if event.props is not None else {}
        return cls(uuid=event.entity_uuid, **props)
