import gzip

from .g_code_parser import GCodeParser
from typing import List


class GzipGCodeParser(GCodeParser):
    def __init__(self, file_path: str) -> None:
        super().__init__(file_path)

    def open_stream(self, codec_error=None):
        return gzip.open(self._file_path, "rt", errors=codec_error, encoding="utf-8")

    @classmethod
    def get_supported_file_types(cls) -> List[str]:
        return ["gcode.gz", "gzgcode", "g.gz"]
