from typing import Dict, Any

from app.models.material import Material


class Extruder:
    HOTEND_DIAMETERS = {
        "AA 0.4": "0.4",
        "BB 0.4": "0.4",
        "AA 0.8": "0.8",
        "BB 0.8": "0.8"
    }

    def __init__(self, data: Dict[str, Any]) -> None:
        self.material = Material(data["active_material"]["GUID"])   # type: Material
        self.hotend_id = data["hotend"]["id"]   # type: str
        self.hotend_diameter = self.HOTEND_DIAMETERS.get(self.hotend_id, None)  # type: str
