from typing import Optional


MYPY = False
if MYPY:
    from app.models.printer import Printer
    from app.models.print_job import PrintJob
    from app.services.scheduler.result_containers.match_results import MatchResult


# This is the base class for all the match rules.
class MatchRule:
    def apply(self, printer: "Printer", print_job: "PrintJob") -> Optional["MatchResult"]:
        raise NotImplementedError("No Match function was implemented")
