from app.models.print_job import PrintJob
from app.models.printer import Printer
from app.services.scheduler.match_rule import MatchRule, Optional
from app.services.scheduler.result_containers.match_results import IncompatibleMatchResult, MatchResult


class IsAuthenticatedMatchRule(MatchRule):
    def apply(self, printer: Printer, print_job: PrintJob) -> Optional[MatchResult]:
        if not printer.is_authenticated():
            return IncompatibleMatchResult(
                origin=self,
                debug_message="The printer is not authenticated, so prints can not be started on it.",
                translation_key="printer_is_not_authenticated"
            )
        return None
