from app.constants.printer_status import PrinterStatus
from app.models.print_job import PrintJob
from app.models.printer import Printer
from app.services.scheduler.match_rule import MatchRule, Optional
from app.services.scheduler.result_containers.match_results import FutureMatchResult, MatchResult


class IsPrinterInPrePrintMatchRule(MatchRule):
    def apply(self, printer: Printer, print_job: PrintJob) -> Optional[MatchResult]:
        if printer.status == PrinterStatus.PRE_PRINT:
            return FutureMatchResult(
                time=float("inf"),
                origin=self,
                debug_message="Printer is in pre-printing stage",
                translation_key="printer_in_preprint"
            )
        return None
