from app.constants.printer_status import PrinterStatus
from app.models.print_job import PrintJob
from app.models.printer import Printer
from app.services.scheduler.match_rule import MatchRule, Optional
from app.services.scheduler.result_containers.match_results import IncompatibleMatchResult, MatchResult


class IsPrinterInUnknownStateMatchRule(MatchRule):
    def apply(self, printer: Printer, print_job: PrintJob) -> Optional[MatchResult]:
        if printer.status == PrinterStatus.UNKNOWN:
            return IncompatibleMatchResult(
                origin=self,
                debug_message="Printer is in unknown state",
                translation_key="unknown_state"
            )
        return None
