from app.events.printer_added_event import PrinterAddedEvent
from app.events.printer_deleted_event import PrinterDeletedEvent
from app.events.printer_status_changed_event import PrinterStatusChangedEvent
from app.events.printer_updated_event import PrinterUpdatedEvent
from app.libs.signal import Signal
from app.models.printer import Printer
from app.models.printer_collection import PrinterCollection
from app.storage.event_store import EventStore
from .abstract_event_storage_manager import AbstractEventStorageManager


class PrinterEventStorageManager(AbstractEventStorageManager[Printer]):
    def __init__(self, event_store: EventStore, replay_done: Signal, collection: PrinterCollection) -> None:
        super().__init__(
            event_store=event_store,
            replay_done=replay_done,
            collection=collection,
            add_event=PrinterAddedEvent,
            modify_events=[PrinterUpdatedEvent, PrinterStatusChangedEvent],
            delete_event=PrinterDeletedEvent,
            model=Printer
        )
