#!/usr/bin/env python3

import os
import sys

local_pip_directory = os.path.join(os.path.abspath(os.path.dirname(__file__)), "pip_packages")

if os.path.exists(local_pip_directory):
    sys.path.insert(0, local_pip_directory)

from flask_script import Server, Manager
from app.app import create_app

# default to dev config
env = os.environ.get("APPNAME_ENV", "dev")
app = create_app("app.settings.%sConfig" % env.capitalize())

manager = Manager(app)
manager.add_command("server", Server(threaded=True, processes=1, use_reloader=False))
# Note that the reloader causes the application to be created twice! Thus, we turn it off.
# Also, our application is intended to run in one process.

if __name__ == "__main__":
    manager.run()
