#!/bin/sh

set -eu

UPDATE_ROOT_DIR="${UPDATE_ROOT_DIR:-${1}}"
if [ ! -d "${UPDATE_ROOT_DIR}" ]; then
	echo "Missing location of the extracted tarball supplied."
	exit 1
fi

UPDATE_TARGET_DIR="/"

echo "Rsyncing the new install over the current install, skipping any other mounts."
rsync --exclude='/tmp/' --exclude='/var/lib/griffin/' --exclude='/var/lib/connman/' --exclude='/media/' --exclude='/etc/dropbear/' -c -a --delete -x "${UPDATE_ROOT_DIR}/" "${UPDATE_TARGET_DIR}"

# TODO OK-63 replace usbmount with an alternative such as udisks2
# usbmount expects these directories to always exist.
if [ -x "/var/lib/dpkg/info/usbmount.preinst" ]; then
	/var/lib/dpkg/info/usbmount.preinst "install"
fi

echo "Update of rootfs complete."
