from griffin.history.alchemy.database_link import Base
from sqlalchemy import Column, String, Integer, ForeignKey
from sqlalchemy.orm import relationship

## @brief Database representation of a EventRecord.
#  Represents a single parameter to an event. Each event can have zero or more parameters associated with it.
#  Note, if you modify this database layout, you need to build a migration file and increase the version number in the database.
#       See databaseService.py as start point for migrations.
class EventParameterRecord(Base):
    __tablename__ = "EventParameters"

    event_id = Column(Integer, ForeignKey('Events.id'), index=True, primary_key=True)
    key = Column(Integer, index=True, primary_key=True)
    value = Column(String)

    event = relationship("EventRecord", back_populates="parameters")
