from griffin.history.alchemy.database_link import Base
from sqlalchemy import Column, String, Integer, Interval, DateTime
from sqlalchemy.orm import relationship

## @brief Database representation of a EventRecord.
#  Represents a single record in the event log.
#  Note, if you modify this database layout, you need to build a migration file and increase the version number in the database.
#       See databaseService.py as start point for migrations.
class EventRecord(Base):
    __tablename__ = "Events"

    id = Column(Integer, primary_key=True)
    time = Column(DateTime, index=True)
    event_type_id = Column(Integer, index=True)

    # Setup the one-to-many relationship of parameters belonging to this event.
    parameters = relationship("EventParameterRecord", back_populates="event", order_by="EventParameterRecord.key", cascade="all, delete, delete-orphan")
