from griffin.history.alchemy.database_link import Base
from sqlalchemy import Column, String, Integer


## @brief Database representation of a PrinterSettingRecord.
#  Represents a single record in the print settings table.
#  Note, if you modify this database layout, you need to build a migration file and increase the version number in the database.
#       See databaseService.py as start point for migrations.
class PrinterSettingRecord(Base):
    __tablename__ = "PrinterSettings"

    name = Column(String, primary_key=True)
    setting_value = Column(Integer)

    ## @brief Get table name
    # @returns Returns PrinterSetting table name
    @staticmethod
    def get_table_name():
        return PrinterSettingRecord.__tablename__
