import os

from griffin import dbusif
from griffin.interface.http.exposedItems.httpExposedObject import HttpExposedObject
from griffin.interface.http.flaskResponses import FlaskResponses
from griffin.printer.printerService import PrinterService


class PrintJobGcode(HttpExposedObject):
    def __init__(self, local_path, parent):
        super().__init__(local_path, parent, authenticated_methods=['GET'])

    def get(self):
        printer_service = dbusif.RemoteObject("printer")  # type: PrinterService
        file_path = printer_service.getProcedureMetaData("PRINT").get("file_path")  # type: str
        if file_path == "":
            return FlaskResponses.createNoContent("")
        mime_type = "application/gzip" if file_path.lower().endswith("gz") else "text/plain"
        file_name = os.path.basename(file_path)
        return FlaskResponses.createFileResponse(file_name, file_path, mime_type)

    # @return This should NOT be included in the get of a sub path.
    def includeInDataTree(self):
        return False
