from griffin.interface.http.exposedItems.httpExposedType import HttpExposedType
from griffin.interface.http.flaskResponses import FlaskResponses

import logging

log = logging.getLogger(__name__.split(".")[-1])


## @brief HttpExposedDict is a special case of an HttpExposedType, returning a JSON formatted dictionary
class HttpExposedDict(HttpExposedType):

    def __init__(self, *args, **kwargs):
        super().__init__(dict, *args, **kwargs)

    ## @brief Get the dictionary and show it as a json dict
    def get(self):
        data = self._get_function()
        log.info("HttpExposedDict: {}".format(data))
        return FlaskResponses.createSuccess(json=data)
