import logging

from griffin.printer.procedures.procedureStep import ProcedureStep

log = logging.getLogger(__name__.split(".")[-1])


## Step to indicate that we are updating firmware on remote hardware.
#  This step just waits till all the procedures are done.
class WaitForHardwareInitializationFinished(ProcedureStep):
    def __init__(self, key, hardware_initializers):
        super().__init__(key)
        self.__hardware_initializers = hardware_initializers

    # Run till all the initializers are finished.
    def run(self):
        for initializer in self.__hardware_initializers:
            initializer["thread"].join()
