from griffin.printer.controller import Controller
from griffin.printer.procedures.procedureStep import ProcedureStep


class WipeNozzleStep(ProcedureStep):
    def __init__(self, key):
        super().__init__(key)

    def run(self):
        c = Controller.getInstance()

        # Wipe left or right, depending on our position from the middle.
        x = c.getPosition("X")
        if c.getPropertyValue("build_volume")["x"] / 2.0 > x:
            move = 10
        else:
            move = -10

        speed = c.getPropertyValue("default_travel_speed") * (1.0 / (c.getPropertyValue("movement_speed_modifier") / 100.0))
        c.sendRawGCode("G1 X%d F%d" % (x + move, speed * 60.0), wait=False)
