from griffin.printer.procedures.procedureStep import ProcedureStep
from griffin.printer.controller import Controller
from griffin.printer.buildPlateLocations import BuildPlateLocations

import logging
log = logging.getLogger(__name__.split(".")[-1])


## This class gets the current head position and stores this in the given dictionary.
class GetCurrentPositionStep(ProcedureStep):
    # @param key: Name of this step
    # @param storage_dictionary: Dictionary that will be filled with the "x" "y" "z" and "e" keys, which will reflect the current target head position.
    def __init__(self, key, storage_dictionary):
        super().__init__(key)
        assert isinstance(storage_dictionary, dict)
        self.__storage_dictionary = storage_dictionary

    def run(self):
        self.__storage_dictionary["x"] = Controller.getInstance().getPosition("X")
        self.__storage_dictionary["y"] = Controller.getInstance().getPosition("Y")
        self.__storage_dictionary["z"] = Controller.getInstance().getPosition("Z")
        self.__storage_dictionary["e"] = Controller.getInstance().getPosition("E")
