from griffin.printer.procedures.procedureStep import ProcedureStep
from griffin.printer.controller import Controller

import logging
log = logging.getLogger(__name__.split(".")[-1])


## Sets the active hardware hotend without performing a switch (@ref switchActiveHotendStep)
# The reason that this step is needed is because we ask the user to manually perform a hotend switch
# during the calibration of the switching bay. Then we need to enforce the correct hardware hotend.
class SetActiveHardwareHotendStep(ProcedureStep):
    def __init__(self, key, args):
        super().__init__(key)
        if "target" in args:
            self.__target_hotend = int(args["target"])
        else:
            self.__target_hotend = 0

    def run(self):
        log.info("Target hotend = %d" % self.__target_hotend)
        c = Controller.getInstance()
        hardware_active_hotend = c.getPropertyContainer().get("hardware_active_hotend")
        hardware_active_hotend.setBySystem(self.__target_hotend)
