from griffin.printer.procedures.procedureStep import ProcedureStep

import logging
log = logging.getLogger(__name__.split(".")[-1])

# this step breaks its link to the next step it's started once.
class DoOnceStep(ProcedureStep):
    def __init__(self, next_step = None):
        super().__init__("ONCE")
        self.setNextDefaultStep(next_step)
        self._has_ran = False

    def run(self):
        if self._has_ran:
            log.info("{step} has already ran, setting next default step to None".format(step=self))
            self.setNextDefaultStep(None)
        self._has_ran = True
